// invptr.cpp
// 5/4/99
// Solution for pointers to records
// Ken Brownsey

#include "data.h"
#include <iostream.h>


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(r)ead in a new record  **************\n"
			<<	"***	(w)rite out record      **************\n"
			<<	"***	write out (k)ey      **************\n"
			<< "***   e(x)it					   **************\n"
			<< "***   (m)enu						**************\n";
}


// PRE	TRUE
// POST	starts up
void
Initialise(DataRec_T &DataRec) {

	cout	<<	"The wonderful record demonstration program\n\n"
			<<	"Please input a record to begin with\n\n";
	Read_Rec(DataRec);
}

// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(DataRec_T &DataRec) {

	char	Request;
	int	RequestCount;

	cout	<<	"\n\n\n";
	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'r' :	Read_Rec(DataRec);
				break;
			case 'w' :  Write_Rec(DataRec);
				break;
			case 'k' :  Write_Key(Get_Key(DataRec));
				break;
			case 'm' :	Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
			break;
		}

		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	DataRec_T DataRec;

	Initialise(DataRec);
	Loop(DataRec);
	Finalise();
}


