// data.h
// 8/8/98
// data for with records search demo
// Ken Brownsey

#ifndef	DATA_H
#define 	DATA_H

#include <fstream.h>
#include "my_const.h"

typedef int	Key_T;

typedef struct {
	Key_T	Number;
	char	*Name;
} DataRec_T;

// PRE	TRUE
// POST	user is prompted for student key value which is returned
Key_T
Read_Key();


// PRE	TRUE
// POST	key value is written to screen
void
Write_Key(Key_T Key);


// PRE	TRUE
// POST	RETURNS key value of Rec
Key_T
Get_Key(DataRec_T DataRec);


//	PRE	TRUE
//	POST	prompts user for student record
//			which is read into Rec
void
Read_Rec(DataRec_T &Rec);


//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Rec(DataRec_T Rec);


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				RETURNS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
DataRec_T
Read_Rec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);


#endif

