// VertData.cpp
// 14/5/99
// vertex records for Graph_T
// Ken Brownsey

#include "VertData.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>
#include "arc_bst.h"



// PRE	TRUE
// POST	user is prompted for vertex key value which is returned
VertKey_T
Read_VertKey() {
	VertKey_T VertKey;

	cin	>>	VertKey;
	return(VertKey);
}


// PRE	TRUE
// POST	VertKey value is written to screen
void
Write_VertKey(VertKey_T VertKey) {

	cout	<< VertKey;
}


// PRE	TRUE
// POST	returns key value of VertDataRec
VertKey_T
Get_VertKey(VertDataRec_T VertDataRec) {

	return(VertDataRec.Number);
}


// PRE	TRUE
// POST	Returns name of VertDataRec
char
*Get_VertName(VertDataRec_T VertDataRec) {

	return(VertDataRec.Name);
}


//	PRE	TRUE
//	POST	prompts user for vertex record
//			which is read into VertDataRec
void
Read_VertDataRec(VertDataRec_T &VertDataRec) {

	cout	<<	"Number ==> ";
	cin	>>	VertDataRec.Number;
	cout	<<	"Name ==> ";
	VertDataRec.Name = Read_String();
}



//	PRE	TRUE
//	POST	writes VertDataRec to screen
void
Write_VertDataRec(VertDataRec_T VertDataRec) {

	cout	<<	"\nNumber is "
			<<	VertDataRec.Number
			<< "\nName is "
			<<	VertDataRec.Name;
}


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
VertDataRec_T
Read_VertDataRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	VertDataRec_T Result;

	Q_ValidRecFromFile = TRUE;
	InFile	>> Result.Number;
	if (!InFile.eof()) {
		cout	<<	"\nVertex number "
				<< Result.Number;
		Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
		if (!InFile.eof()) {
			cout	<< " Verterx name "
					<<	Result.Name;
		}
		else {
			Q_ValidRecFromFile = FALSE;
		}
	}
	return(Result);
}


// PRE	FileHandle is a correctly opened stream
// POST	VertDataRec written to FileHandle stream
void
Write_VertDataRec_To_File (VertDataRec_T VertDataRec, ofstream &OutFile) {

	OutFile	<<	VertDataRec.Number
				<< "\n"
				<<	VertDataRec.Name
				<< "\n";
}




