// VertData.h
// 14/5/99
// Ken Brownsey
//	Vertex records for Graph_T
#ifndef	VERTDATA_H
#define 	VERTDATA_H

#include <fstream.h>
#include "my_const.h"

typedef int	VertKey_T;

typedef struct {
	VertKey_T	Number;
	char	*Name;
	void	*Arcs;
} VertDataRec_T;

// PRE	TRUE
// POST	user is prompted for student key value which is returned
VertKey_T
Read_VertKey();


// PRE	TRUE
// POST	key value is written to screen
void
Write_VertKey(VertKey_T VertKey);


// PRE	TRUE
// POST	returnS key value of VertDataRec
VertKey_T
Get_VertKey(VertDataRec_T VertDataRec);


// PRE	TRUE
// POST	Returns name of VertDataRec
char
*Get_VertName(VertDataRec_T VertDataRec);


//	PRE	TRUE
//	POST	prompts user for student record
//			which is read into VertDataRec
void
Read_VertDataRec(VertDataRec_T &VertDataRec);


//	PRE	TRUE
//	POST	writes VertDataRec to screen
void
Write_VertDataRec(VertDataRec_T VertDataRec);



// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
VertDataRec_T
Read_VertDataRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);



// PRE	FileHandle is a correctly opened stream
// POST	VertDataRec written to FileHandle stream
void
Write_VertDataRec_To_File (VertDataRec_T VertDataRec, ofstream &OutFile);

#endif
