// vert.cpp
// 14/5/99
// vertex records for Graph_T
// Ken Brownsey

#include "vert.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>

// PRE	TRUE
// POST	user is prompted for vertex key value which is returned
VertKey_T
Read_VertKey() {
	VertKey_T VertKey;

	cin	>>	VertKey;
	return(VertKey);
}


// PRE	TRUE
// POST	VertKey value is written to screen
void
Write_VertKey(VertKey_T VertKey) {

	cout	<< VertKey;
}


// PRE	TRUE
// POST	returns key value of VertRec
VertKey_T
Get_VertKey(VertRec_T VertRec) {

	return(VertRec.Number);
}


//	PRE	TRUE
//	POST	prompts user for vertex record
//			which is read into VertRec
void
Read_VertRec(VertRec_T &VertRec) {

	cout	<<	"Number ==> ";
	cin	>>	VertRec.Number;
	cout	<<	"Name ==> ";
	VertRec.Name = Read_String();
}



//	PRE	TRUE
//	POST	writes VertRec to screen
void
Write_VertRec(VertRec_T VertRec) {

	cout	<<	"\nNumber is "
			<<	VertRec.Number
			<< "\nName is "
			<<	VertRec.Name;
}


// PRE	TRUE
//	POST	Arcs field of Rec set to NewArcs
//	NOTES	This allows programmer to insert first element into arcs
//			and is an implementation forced feature
void
Set_Arcs(VertRec_T VertRec, void	*NewArcs) {
	VertRec.Arcs = NewArcs;
}


//	PRE	TRUE
//	POST
// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
VertRec_T
Read_VertRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	VertRec_T Result;

	Q_ValidRecFromFile = TRUE;
	if (!InFile.eof()) {
		InFile	>> Result.Number;
		if (!InFile.eof()) {
			Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
		}
		else {
			Q_ValidRecFromFile = FALSE;
		}
	}
	else {
		Q_ValidRecFromFile = FALSE;
	}
	return(Result);
}


// PRE	FileHandle is a correctly opened stream
// POST	VertRec written to FileHandle stream
void
Write_VertRec_To_File (VertRec_T VertRec, ofstream &OutFile) {

	OutFile	<<	VertRec.Number
				<< "\n"
				<<	VertRec.Name
				<< "\n";
}




