// rec_util.h
// 23/8/98
// Recursive procedures on Stack_T
// Ken Brownsey

#include "iostream.h"
#include "stack.h"

// PRE	TRUE
// POST	Stack printed out in order of recentness
void
Print_Stack_R(Stack_T Stack);


// PRE	TRUE
// POST	RETURNS size of Stack
int
Get_Size_R(Stack_T Stack);


// PRE	TRUE
// POST	RETURNS copy of Stack
Stack_T
Copy_Stack_R(Stack_T Stack);


// PRE	TRUE
// POST	Q_EmptyStack(Stack)
void
Make_Empty_R(Stack_T Stack);


// PRE	TRUE
// POST	IF Element is in Stack
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Member_R(Element_T Element, Stack_T Stack);



// PRE	TRUE
// POST	IF Q_Member_R(El, Stack)
//				Stack' = Stack with first occurrence of El removed
//			ELSE
//				Stack' = Stack
void
Delete_R(Element_T El, Stack_T Stack);


// PRE	TRUE
// POST	RETURNS stack containing all members of
//				Stack1 that are not in Stack2
//				IF e occurs n times in Stack1 and
//					m times in Stack2, and n > m
//						e occurs n - m times in RETURNED stack
//			Stack2 will, in general, be altered
Stack_T
Complement_R(Stack_T Stack1, Stack_T Stack2);


