// data.h
// 5/4/99
// Solution to pointer to records exercise
// Ken Brownsey

typedef enum	Dept_T {Toys, Food, Clothing};

typedef int InvNum_T;
typedef float Balance_T;

typedef struct {
	int	DD;
	int	MM;
	int	YY;
} Date_T;

typedef struct {
	InvNum_T		InvoiceNum;
	Balance_T	Balance;
	enum 	Dept_T Dept;
	Date_T	Date;
} IRec_T, *IRec_Ptr_T;

typedef InvNum_T	Key_T;
typedef IRec_Ptr_T DataRec_T;

// PRE	TRUE
// POST	user is prompted for student key value which is returned
Key_T
Read_Key();


// PRE	TRUE
// POST	key value is written to screen
void
Write_Key(Key_T Key);


// PRE	TRUE
// POST	RETURNS key value of DataRec_T
Key_T
Get_Key(DataRec_T DataRec);


//	PRE	TRUE
//	POST	prompts user for student record
//			which is read into DataRec
void
Read_Rec(DataRec_T &DataRec);


//	PRE	TRUE
//	POST	writes DataRec to screen
void
Write_Rec(DataRec_T DataRec);

