// searchdb.h
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey

#ifndef	SEARCHDB_H
#define 	SEARCHDB_H

#include "my_const.h"
#include "sequence.h"
#include "data.h"


typedef Sequence_T SearchDB_T;


//	PRE	Q_Full(DB) is FALSE
//       AND keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Value(int Value, SearchDB_T DB);


// PRE	DB is in ascending key order
// POST	IF Value is in DB
//				Position is position in DB
//				AND key of current record in DB'
//              = Key
//				RETURNS TRUE
//			ELSE
//				IF at least one value in DB > Value
//					Position is that of the
//					next largest to Value
//				ELSE
//					Position is that of last in DB
//					RETURNS FALSE
BOOLEAN
Q_PresentOrd(int Value, SearchDB_T DB, int &Position);


// PRE	TRUE
// POST	User is prompted for filename
//			IF this is a file of Element_T's
//				these are loaded into DBase
//				except for those already there
//				which are printed with appropriate message
void
Load_DB_From_File(SearchDB_T SearchDB);


//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SearchDB_T DB);

#endif
