// arc.cpp
// 14/5/99
// arc records for Graph_T
// Ken Brownsey

#include "arc.h"
#include <iostream.h>
#include "rd_str.h"
#include <string.h>

// PRE	TRUE
// POST	user is prompted for arc key value which is returned
ArcKey_T
Read_ArcKey() {
	ArcKey_T ArcKey;

	cin	>>	ArcKey;
	return(ArcKey);
}


// PRE	TRUE
// POST	ArcKey value is written to screen
void
Write_ArcKey(ArcKey_T ArcKey) {

	cout	<< ArcKey;
}


// PRE	TRUE
// POST	returns key value of ArcRec
ArcKey_T
Get_ArcKey(ArcRec_T ArcRec) {

	return(ArcRec.Number);
}


// PRE	TRUE
// POST	returnS key value of source vertex in ArcRec
VertKey_T
Get_FromVertKey(ArcRec_T ArcRec) {
	return(Get_VertKAPRecKey(ArcRec.FromVertKAPRec));
}



// PRE	TRUE
// POST	returnS key value of sink vertex in ArcRec
VertKey_T
Get_ToVertKey(ArcRec_T ArcRec)  {
	return(Get_VertKAPRecKey(ArcRec.ToVertKAPRec));
}


//	PRE	TRUE
//	POST	prompts user for arc details
//			which are read into ArcRec
void
Read_ArcRecDetails(ArcRec_T &ArcRec) {

	cout	<<	"Number ==> ";
	cin	>>	ArcRec.Number;
	cout	<<	"Name ==> ";
	ArcRec.Name = Read_String();
}



//	PRE	TRUE
//	POST	writes ArcRec to screen
void
Write_ArcRec(ArcRec_T ArcRec) {

	cout	<<	"\nNumber is "
			<<	ArcRec.Number
			<< "\nName is "
			<<	ArcRec.Name;
}


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
/*ArcRec_T
Read_ArcRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile) {
	ArcRec_T Result;

	Q_ValidRecFromFile = TRUE;
	if (!InFile.eof()) {
		InFile	>> Result.Number;
		if (!InFile.eof()) {
			Result.Name = Read_String_From_File(InFile, Q_ValidRecFromFile);
			if (!InFile.eof()) {
				InFile	>> Result.VertKey;
			}
			else {
				Q_ValidRecFromFile = FALSE;
			}
		}
		else {
			Q_ValidRecFromFile = FALSE;
		}
	}
	else {
		Q_ValidRecFromFile = FALSE;
	}
	return(Result);
} */


// PRE	FileHandle is a correctly opened stream
// POST	ArcRec written to FileHandle stream
void
Write_ArcRec_To_File (ArcRec_T ArcRec, ofstream &OutFile) {

	OutFile	<<	ArcRec.Number
				<< "\n"
				<<	ArcRec.Name
				<< "\n";
}


