// rec_util.cpp
// 23/8/98
// Recursive procedures on Stack_T
// Ken Brownsey

#include "rec_util.h"

// PRE	TRUE
// POST	Stack printed out in order of recentness
void
Print_Stack_R(Stack_T Stack) {
	Element_T NextEl;

	if (!Q_EmptyStack(Stack)) {
		NextEl = Top(Stack);
		Write_Rec(NextEl);
		cout	<< " ";
		Pop(Stack);
		Print_Stack_R(Stack);
		Push(NextEl, Stack);
	}
}


// PRE	TRUE
// POST	RETURNS number of items in Stack
int
Get_Size_R(Stack_T Stack) {
	int SizeOfRest;
	Element_T NextEl;

	cout	<< "\n\nA function to find the stack size\n"
			<< "It is not really a surprise\n"
			<< "How do you find SizeOfRest?\n"
			<< "Answer this simple request\n"
			<< "The key comes to the recursively wise\n\n";
	// The following lines are part of the solution
	// except where otherwise indicated
	if (!Q_EmptyStack(Stack)) {
	// The next two lines to be removed in the answer
		cout	<< "Stack is not empty";
		SizeOfRest = 42;
		return(1 + SizeOfRest);
	}
	else {
		return(0);
	}
}


// PRE	TRUE
// POST	RETURNS copy of Stack
Stack_T
Copy_Stack_R(Stack_T Stack) {
	Element_T NextEl;
	Stack_T Result;

	cout	<< "\n\nNow to fix the recursive copy stack\n"
			<< "You will not make it work with a quick hack\n"
			<< "Think about all cases\n"
			<< "Recursive and bases\n"
			<< "And look at Print_Stack_R to get the right tack\n\n";
	// The following lines are part of the solution
	// except where otherwise indicated
	if (!Q_EmptyStack(Stack)) {
		// The next two lines to be removed in the answer
		cout	<< "Stack is not empty";
		Result = Create_Stack();
	}
	else {
		Result = Create_Stack();
	}
	return(Result);
}



// PRE	TRUE
// POST	Q_EmptyStack(Stack)
void
Make_Empty_R(Stack_T Stack) {

	cout	<< "\n\nClearing up memory is good management\n"
			<< "This should always be your very best intent\n"
			<< "No doubt there will be some popping\n"
			<< "And now there should be no stopping\n"
			<< "Your working out the answer is imminent\n";
}


// PRE	TRUE
// POST	IF Element is in Stack
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Member_R(Element_T Element, Stack_T Stack) {
	Element_T TopEl;

	if (Q_EmptyStack(Stack)) {
		return(FALSE);
	}
	else {
		TopEl = Top(Stack);
		if (Element == TopEl) {
			return(TRUE);
		}
		else {
			Pop(Stack);
			if (Q_Member_R(Element, Stack)) {
				Push(TopEl, Stack);
				return(TRUE);
			}
			else {
				Push(TopEl, Stack);
				return(FALSE);
			}
		}
	}
}


// PRE	TRUE
// POST	IF Q_Member_R(El, Stack)
//				Stack' = Stack with first occurrence of El removed
//			ELSE
//				Stack' = Stack
void
Delete_R(Element_T El, Stack_T Stack) {
	Element_T TopEl;

	cout	<< "\n\nDeletion of an element\n"
			<< "Is no impediment\n"
			<< "Start it now\n"
			<< "You'll see how\n"
			<< "It leaves the stack as the postcondition meant\n";
}



// PRE	TRUE
// POST	RETURNS stack containing all members of
//				Stack1 that are not in Stack2
//				IF e occurs n times in Stack1 and
//					m times in Stack2, and n > m
//						e occurs n - m times in RETURNED stack
//			Stack2 will, in general, be altered
Stack_T
Complement_R(Stack_T Stack1, Stack_T Stack2) {
	Element_T TopEl;
	Stack_T	Result;

	cout	<< "\n\nThis is to find the complement of a set\n"
			<< "To store a set, a stack is here what we get\n"
			<< "Order of elements\n"
			<< "Is of no relevance\n"
			<< "Just ensure that the postconditions are met\n\n";

	// The following lines are part of the solution
	// except where otherwise indicated
	if (Q_EmptyStack(Stack1)) {
		Result = Create_Stack();
	}
	else {
		// The next two lines to be removed in the answer
		cout	<< "\n\nStack is not empty\n";
		Result = Create_Stack();
	}
	return(Result);
}



