// Ken Brownsey
// 31/8/98
// bst_tree.cpp
// BST_T

#include "bst_tree.h"
#include <stddef.h>

// PRE	TRUE
// POST	IF record with key Key is in BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BST_Present_R(Key_T Key, BST_T BST) {
	if (Q_EmptyTree(BST)) {
		return(FALSE);
	}
	else {
		if (Key < Get_Key(Get_Root(BST))) {
			return(Q_BST_Present_R(Key, Get_Left(BST)));
		}
		else {
			if (Key > Get_Key(Get_Root(BST))) {
				return(Q_BST_Present_R(Key, Get_Right(BST)));
			}
			else {
				return(TRUE);
			}
		}
	}
}


// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	RETURNS BST with Rec inserted
BST_T
BST_Insert_R(Element_T Rec, BST_T BST) {
	if (Q_EmptyTree(BST)) {
		return(Make_Tree(Create_Tree(), Rec, Create_Tree()));
	}
	else {
		if (Get_Key(Rec) < Get_Key(Get_Root(BST))) {
			return(Make_Tree(	BST_Insert_R(Rec, Get_Left(BST)),
						Get_Root(BST),
						Get_Right(BST)));
		}
		else {
			return(Make_Tree(	Get_Left(BST),
								Get_Root(BST),
								BST_Insert_R(Rec, Get_Right(BST))));
		}
	}
}


// PRE	Q_BST_Present_R(Key, BST)
// POST	RETURNS record with key value Key from BST
Element_T
BST_Retrieve_R(Key_T Key, BST_T BST) {
	// All lines between here and the closing } bracket
   //	will be absent from or different in the solution
	Element_T	Dummy;


	Dummy.Number = -999;
	Dummy.Name = "\nNothing here";
	cout	<<	"\nYour eyes do not deceive"
			<<	"\nThere is nothing for retrieve"
			<<	"\nDo it now"
			<<	"\nYou know how"
			<<	"\nBetter than you believe";
	return(Dummy);
}




// PRE	NOT Q_EmptyTree(BST)
// POST	RETURNS rightmost Element_T of BST
Element_T
Get_RightMost_R(BST_T BST) {
	cout	<<	"\nTo get to the node furthest right"
			<<	"\nFrom node to node right as you might"
			<<	"\nStart at the root"
			<<	"\nAnd off you shoot"
			<<	"\nThis will help your Delete_R plight";
}


// PRE	TRUE
// POST	IF (Q_BST_Present(Rec, BST)
//				RETURNS BST with Rec deleted
//			ELSE
//				RETURNS BST
BST_T
BST_Delete_R(Key_T Key, BST_T BST) {
	Element_T NewRoot;

	if (Q_EmptyTree(BST)) {
		return(BST);
	}

	if (Key < Get_Key(Get_Root(BST))) {
		return(Make_Tree(	BST_Delete_R(Key, Get_Left(BST)),
								Get_Root(BST),
								Get_Right(BST)));
	}

	if (Key > Get_Key(Get_Root(BST))) {
		return(Make_Tree(	Get_Left(BST),
								Get_Root(BST),
								BST_Delete_R(Key, Get_Right(BST))));
	}

	if (Q_EmptyTree(Get_Left(BST))) {
		return(Get_Right(BST));
	}

	if (Q_EmptyTree(Get_Right(BST))) {
		return(Get_Left(BST));
	}

	cout	<<	"\nHow to delete a root with two sub trees"
			<<	"\nSuch a programmer can command large fees"
			<<	"\nThink it through"
			<<	"\nUp to you"
			<<	"\nDiagrams and thought are often the best keys";
// This next line must go
Element_T Dummy;
// This next line will look different
	Dummy = Get_RightMost_R(BST);
	// The next line will also be different
	return(BST);
}


