// Ken Brownsey
// 31/8/98
// bst_tree.h
// BST_T

#ifndef BST_TREE_H
#define BST_TREE_H

#include "rec_tree.h"


typedef BT_T BST_T;

// PRE	TRUE
// POST	IF Rec is in BST
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BST_Present_R(Key_T Key, BST_T BST);

// PRE	NOT Q_BST_Present_R(Rec, BST)
// POST	RETURNS BST with Rec inserted
BST_T
BST_Insert_R(Element_T Rec, BST_T BST);


// PRE	Q_BST_Present_R(Key, BST)
// POST	RETURNS record with key value Key from BST
Element_T
BST_Retrieve_R(Key_T Key, BST_T BST);

// PRE	TRUE
// POST	IF (Q_BST_Present(Rec, BST)
//				RETURNS BST with Rec deleted
//			ELSE
//				RETURNS BST
BST_T
BST_Delete_R(Key_T Key, BST_T BST);

#endif